--[[
requests:
target buffs/debuffs - done
filter just players buffs/debuffs

]]


local CheckIsMine = nil
-- ^^ to create the config frames ^^
local ConfigShown --to toggle the config
local ActiveButton -- the button that has been clicked to bring up the menu

local function BuffedOnDragStart(self, index, button)
local BuffButton = _G[self..index]
	if (button == "LeftButton") then 
		BuffButton:StartMoving()
	elseif (button == "RightButton") then 
		ActiveButton = BuffButton
		ToggleDropDownMenu(1, nil, _G["BuffedBuffConfig"], BuffButton, 30, 20)
	end
end

local function BuffedOnDragStop(self, index)
	local BuffButton = _G[self..index]
	BuffButton:StopMovingOrSizing()
	for FrameName, sub in pairs(BuffedFrameCreation) do	
	for i = 1, sub.number do
	local BBleft, BBright, BBtop, BuffBottom = BuffButton:GetLeft(),  BuffButton:GetRight(),  BuffButton:GetTop(),  BuffButton:GetBottom()
	local BBpoint, BBrelativeTo, BBrelativePoint, BBxofs, BByofs = BuffButton:GetPoint()	
		if not ( i == index ) then
			local frame = _G["Buffed"..FrameName..i]
			local point, relativeTo, relativePoint, xofs, yofs = frame:GetPoint()
			local height, width = frame:GetHeight(), frame:GetWidth()
				if ( BByofs > (yofs - 150) ) and ( BByofs < (yofs + 150)) and ( BBxofs > (xofs - 150) ) and ( BBxofs < (xofs + 150)) then
					if ( BBxofs > (xofs - 10) ) and ( BBxofs < (xofs + 10))   then
						if BuffButton.StickyPos then
							BuffButton:ClearAllPoints()
							BuffButton:SetPoint(BBpoint, BBrelativeTo, BBrelativePoint, xofs, BByofs)
						end
						if BuffButton.StickySize then
							BuffButton:SetWidth(width)
							BuffButton:SetHeight(height)
						end
					end
					if ( BByofs > (yofs - 10) ) and ( BByofs < (yofs + 10) ) then
						if BuffButton.StickyPos then
							BuffButton:ClearAllPoints()
							BuffButton:SetPoint(BBpoint, BBrelativeTo, BBrelativePoint, BBxofs, yofs)
						end
						if BuffButton.StickySize then
							BuffButton:SetWidth(width)
							BuffButton:SetHeight(height)
						end
					end	
				end
			end
		end
	end
		BuffedUpdate()
end

local function CreateConfigFrames()
	for FrameName, sub in pairs(BuffedFrameCreation) do -- create all the frames from the table
		for i = 1, 32 do 
			local f = CreateFrame("Button", "Buffed"..FrameName..i, UIParent, "AuraButtonTemplate")
			f:SetMovable(true)
			f.corner = CreateFrame("Button", "Buffed"..FrameName.."Corner"..i, f, f)
			f.corner:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT")
			f.corner:SetPoint("TOPLEFT", f, "CENTER", -5, 5)
			f.corner:SetMovable(true)
			f.cornerT = f.corner:CreateTexture()
			f.cornerT:SetTexture("Interface\\AddOns\\Buffed!\\ResizerButton.tga")
			f.cornerT:SetAllPoints(f.corner)
			f.corner:Hide()
			f.StickyPos = 1
			f.StickySize = 1
			f:SetResizable(true)
			f:SetMaxResize(80,80)
			f:SetMinResize(15,15)
			f.corner:SetResizable(true)
			f:EnableMouse(true)
			f.corner:EnableMouse(true)
			f:SetScript("OnMouseDown", function(self, button) BuffedOnDragStart("Buffed"..FrameName, i, button) end)
			f:SetScript("OnMouseUp", function()  BuffedOnDragStop("Buffed"..FrameName, i) end)
			f.corner:SetScript("OnMouseDown", function()  f:StartSizing(); end)
			f.corner:SetScript("OnMouseUp", function() f:StopMovingOrSizing(); BuffedUpdate(); end)
			f.fs = f:CreateFontString( "FS"..i, "OVERLAY", "GameFontNormal")
			f.fs:SetAllPoints(f)
			f.fs:SetText(i)
			f.fs:SetPoint("CENTER")
			f:SetPoint("CENTER", UIParent, "CENTER")
			f.t = f:CreateTexture()
			f.t:SetTexture("Interface\\AddOns\\Buffed!\\ConfTexture.tga")
			f.t:SetAllPoints(f)
			f.t:SetVertexColor(sub.r,sub.g,sub.b)
			f:Hide()
		end
	end
	local ConFrame = CreateFrame("Frame")

local ConfigLayout = {  
	BuffSlider = { Ftype = "Slider", Inherits = "OptionsSliderTemplate",
		FName = "BuffedBuffSlider", Location = "CENTER", Xoff = 0,Yoff = 150, Parent = ConFrame,
		Min = 0, Max = 32, Step = 1, StartVal = BuffedFrameCreation.Buff.number,LowText = 0, HighText = 32,
		Script1 = {event = "OnValueChanged", func = function(self) BuffedFrameCreation.Buff.number = self:GetValue(); _G["BuffString"]:SetText(self:GetValue()) end,}
				},
	DebuffSlider = { Ftype = "Slider", Inherits = "OptionsSliderTemplate",
		FName = "BuffedDebuffSlider", Location = "CENTER", Xoff = 0, Yoff = 100, Parent = ConFrame,
		Min = 0, Max = 16, Step = 1, StartVal = BuffedFrameCreation.Debuff.number, LowText = 1, HighText = 16,
		Script1 = {event = "OnValueChanged", func = function(self) BuffedFrameCreation.Debuff.number = self:GetValue(); _G["DebuffString"]:SetText(self:GetValue()) end,}
				},
	TargetBuffSlider = { Ftype = "Slider", Inherits = "OptionsSliderTemplate",
		FName = "BuffedTargetBuffSlider", Location = "CENTER", Xoff = 0, Yoff = 50, Parent = ConFrame,
		Min = 0, Max = 16, Step = 1, StartVal = BuffedFrameCreation.TargetBuff.number, LowText = 1, HighText = 16,
		Script1 = {event = "OnValueChanged", func = function(self) BuffedFrameCreation.TargetBuff.number = self:GetValue(); _G["TargBuffString"]:SetText(self:GetValue())end,}
				},
	TargetDebuffSlider = { Ftype = "Slider", Inherits = "OptionsSliderTemplate",
		FName = "BuffedTargetDebuffSlider", Location = "CENTER", Xoff = 0, Yoff = 0, Parent = ConFrame,
		Min = 0, Max = 16, Step = 1, StartVal = BuffedFrameCreation.TargetDebuff.number, LowText = 1, HighText = 16,
		Script1 = {event = "OnValueChanged", func = function(self) BuffedFrameCreation.TargetDebuff.number = self:GetValue(); _G["TargDebuffString"]:SetText(self:GetValue())end,}
				},
	BuffString = { Ftype = "FontString", Location = "CENTER", Xoff = 110, Yoff = 150, Parent = ConFrame["BuffSlider"],
					R = 1, G = 1, B = 1, Width = 60, Height = 15,	
				},
	DebuffString = { Ftype = "FontString", Location = "CENTER", Xoff = 110, Yoff = 100, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 60, Height = 15,	
				},
	TargBuffString = { Ftype = "FontString", Location = "CENTER", Xoff = 110, Yoff = 50, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 60, Height = 15,	
				},
	TargDebuffString = { Ftype = "FontString", Location = "CENTER", Xoff = 110, Yoff = 0, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 60, Height = 15,	
				},
	TitleString = { Ftype = "FontString", Location = "CENTER", Xoff = 0, Yoff = 200, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 150, Height = 15, StringVal = "Buffed! Options",
				},
	BuffLabel = { Ftype = "FontString", Location = "CENTER", Xoff = -120, Yoff = 150, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 150, Height = 15, StringVal = "Buff Count:",
				},
	DebuffLabel = { Ftype = "FontString", Location = "CENTER", Xoff = -120, Yoff = 100, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 150, Height = 15, StringVal = "Debuff Count:",
				},
	TargetBuffLabel = { Ftype = "FontString", Location = "CENTER", Xoff = -120, Yoff = 50, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 150, Height = 15, StringVal = "Target buff:",
				},
	TargetDebuffLabel = { Ftype = "FontString", Location = "CENTER", Xoff = -120, Yoff = 0, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 150, Height = 15, StringVal = "Target debuff:",
				},
}

local Text = {}
for Name, values in pairs(ConfigLayout) do 

if ( values.Ftype == "Frame" ) or ( values.Ftype == "Slider" ) then
	ConFrame[Name] = CreateFrame(values.Ftype, values.FName, values.Parent, values.Inherits)
	if ( values.Ftype == "Slider" ) then
		ConFrame[Name]:SetMinMaxValues(values.Min,values.Max)
		ConFrame[Name]:SetValueStep(values.Step)
		ConFrame[Name]:SetValue(values.StartVal)
		_G[values.FName.."Low"]:SetText(values.LowText)
		_G[values.FName.."High"]:SetText(values.HighText)
		ConFrame[Name]:SetScript(values["Script1"].event, values["Script1"].func)
	end
end
if ( values.Ftype == "FontString" ) then
	ConFrame[Name] = ConFrame:CreateFontString(Name, "OVERLAY", "GameFontNormal")
	ConFrame[Name]:SetWidth(values.Width)
	ConFrame[Name]:SetHeight(values.Height)
	ConFrame[Name]:SetTextColor(values.R,values.G,values.B)
	if values.StringVal then
		ConFrame[Name]:SetText(values.StringVal)
	end
end
ConFrame[Name]:SetPoint(values.Location,values.Xoff,values.Yoff)

end

ConFrame.name = "Buffed!"
InterfaceOptions_AddCategory(ConFrame)

end


local function BuffedOnLoad(self, event, ...)
	if event == "ADDON_LOADED" then
		if select(1, ...) == "Buffed!" then
			if not BuffedFrameCreation then
				BuffedFrameCreation = { Buff = {number = 30, r = 0, g = 1, b = 0}, Debuff = {number = 15, r = 1, g = 0, b = 0}, Wep = {number = 2, r = 1, g = 0, b = 1}, 
						TargetBuff = {number = 16, r = 0, g = 0.4, b = 0}, TargetDebuff = {number = 16, r = 0.4, g = 0, b = 0}}
			end
			CreateConfigFrames()
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		BuffedUpdate()
	end
end

local moop = CreateFrame("Frame")
moop:RegisterEvent("ADDON_LOADED")
moop:RegisterEvent("PLAYER_ENTERING_WORLD")
moop:SetScript("OnEvent", BuffedOnLoad)

local DropDownTest = CreateFrame("Frame", "BuffedBuffConfig", UIParent, "UIDropDownMenuTemplate")
DropDownTest:SetPoint("CENTER")
UIDropDownMenu_SetWidth(DropDownTest, 65)
UIDropDownMenu_SetButtonWidth(DropDownTest, 20)
DropDownTest:Hide()
function DropDownTest_ItemClick()
	UIDropDownMenu_SetSelectedValue(this.owner, this.value);
end

function DropDownTest_Initialize() -- the menu items
	level = level or 1
	local info = UIDropDownMenu_CreateInfo()
			info.text = "Sticky Positioning"
			info.value = 1
			info.checked = nil
			info.tooltipTitle = "Sticky Positioning"
			info.tooltipText = "Aligns the buffs with other nearby buffs"
			info.func = function() if (ActiveButton.StickyPos == 1) then ActiveButton.StickyPos = nil else ActiveButton.StickyPos = 1 end end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Sticky Sizing"
			info.value = 1
			info.checked = nil
			info.tooltipTitle = "Sticky Sizing"
			info.tooltipText = "Sets the size of the buff to other nearby buffs"
			info.func = function()  if (ActiveButton.StickySize == 1) then ActiveButton.StickySize = nil else ActiveButton.StickySize = 1 end end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Sticky Padding"
			info.value = 1
			info.checked = nil
			info.tooltipTitle = "Sticky Padding"
			info.tooltipText = "Attempts to even out the padding between nearby buffs"
			info.func = function() end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Resizable"
			info.value = 1
			info.checked = nil
			info.tooltipTitle = "Resizable"
			info.tooltipText = "Shows a draggable icon to allow buff resizing"
			info.func = function() if ActiveButton.corner:IsShown() then ActiveButton.corner:Hide() else ActiveButton.corner:Show()  end end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Reset Size"
			info.value = 1
			info.checked = nil
			info.tooltipTitle = "Reset Size"
			info.tooltipText = "Resets the size of the buff to default values"
			info.func = function() ActiveButton:SetWidth(30) ActiveButton:SetHeight(30) BuffedUpdate() end
			UIDropDownMenu_AddButton(info, level)
end

UIDropDownMenu_Initialize(DropDownTest, DropDownTest_Initialize, "MENU")

local function ToggleLock()
	if not ConfigShown then
		for FrameName, sub in pairs(BuffedFrameCreation) do
			for i = 1, sub.number do 
				local f = _G["Buffed"..FrameName..i]
				f:Show()
				--print(i.." "..sub.number.." "..FrameName)
			end
		end
		print([[    Green - Buffs 
Red - Debuffs
Dark Green - Target Buffs
Dark Red - Target Debuffs
Purple - Weapon Enchants]])
		ConfigShown = 1
	else
		for FrameName, sub in pairs(BuffedFrameCreation) do
			for i = 1, 32 do 
				local f = _G["Buffed"..FrameName..i]
				if f then
					f:Hide()
				end
			end
		end
		ConfigShown = nil
	end
end


--------------------------------- anchor buffs ---------------------------------

function BuffedBuffButtonAnchors(buttonName, index) 
	local buff = _G[buttonName..index]
	local confbuff = _G["BuffedBuff"..index]
	if (buttonName == "TargetBuffedButton") then
		confbuff = _G["BuffedTargetBuff"..index]
	end
	local width, height  = confbuff:GetWidth(), confbuff:GetHeight()
	local point, relativeTo, relativePoint, xOfs, yOfs = confbuff:GetPoint()
	buff:ClearAllPoints()
	buff:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs)
	buff:SetHeight(height)
	buff:SetWidth(width)
	for i = 1,2 do -- weapon enchant placement
		local buff = _G["TempEnchant"..i]
		local confbuff = _G["BuffedWep"..i]
		if buff then
			local point, relativeTo, relativePoint, xOfs, yOfs = confbuff:GetPoint()
			buff:ClearAllPoints()
			buff:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs)
		end
	end
end


--------------------------   Anchor debuffs ----------------
function BuffedDebuffButtonAnchors(buttonName, index)
	local buff = _G[buttonName..index]
	local confbuff = _G["BuffedDebuff"..index]
	if (buttonName == "TargetDebuffedButton") then
		confbuff = _G["BuffedTargetDebuff"..index]
	end
	local point, relativeTo, relativePoint, xOfs, yOfs = confbuff:GetPoint()
	local width, height  = confbuff:GetWidth(), confbuff:GetHeight()
	
	buff:SetHeight(height)
	buff:SetWidth(width)
	buff:ClearAllPoints()
	buff:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs)
end

SLASH_Buffed1 = "/buffed";
SlashCmdList["Buffed"] = ToggleLock;

---------------------- blizz functions to re-write: ---------------------

function BuffedButtonUpdateDuration(buffButton, timeLeft)
	local duration = getglobal(buffButton:GetName().."Duration");
	if ( SHOW_BUFF_DURATIONS == "1" and timeLeft ) then
		duration:SetFormattedText(SecondsToTimeAbbrev(timeLeft));
		if ( timeLeft < BUFF_DURATION_WARNING_TIME ) then
			duration:SetVertexColor(1, 1, 1);
		else
			duration:SetVertexColor(1, 1, 1);
		end
		duration:Show();
	else
		duration:Hide();
	end
end

function BuffedButtonOnUpdate(self, elapsed, unit)
	local index = self:GetID();
	BuffedButtonUpdateDuration(self, self.timeLeft);
	self.timeLeft = max(self.timeLeft - elapsed, 0);
	if ( BuffFrame.BuffFrameUpdateTime > 0 ) then
		return;
	end
	if ( GameTooltip:IsOwned(self) ) then
		GameTooltip:SetUnitAura(unit, index, self.filter);
	end
end

function BuffedButtonUpdate(buttonName, index, filter, unit)
	local name, rank, texture, count, debuffType, duration, expirationTime, IsMine = UnitAura(unit, index, filter);

	local buffName = buttonName..index;
	local buff = _G[buffName]
	local buffDuration = _G[buffName.."Duration"]
	if ( not name ) then
		-- No buff so hide it if it exists
		if ( buff ) then
			buff:Hide();
			buffDuration:Hide();
		end
		return nil;
	else
		
		local helpful = (filter == "HELPFUL");

		-- If button doesn't exist make it
		if ( not buff ) then
			if ( helpful ) then
				buff = CreateFrame("Button", buffName, BuffFrame, "BuffButtonTemplate");
				buff:SetScript("OnUpdate", nil);
				buff:SetScript("OnEvent", nil);
				buff:SetScript("OnEnter", nil)
				buff:SetScript("OnEnter", function(self)
				GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT");
				GameTooltip:SetUnitAura(unit, self:GetID(), self.filter); end)
			else
				buff = CreateFrame("Button", buffName, BuffFrame, "DebuffButtonTemplate");
				buff:SetScript("OnUpdate", nil);
				buff:SetScript("OnEvent", nil);
				buff:SetScript("OnEnter", nil)
				buff:SetScript("OnEnter", function(self)
				GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT");
				GameTooltip:SetUnitAura(unit, self:GetID(), self.filter); end)
			end
			buffDuration = getglobal(buffName.."Duration");
		end
		-- Setup Buff
		buff.namePrefix = buttonName;
		buff:SetID(index);
		buff.unit = unit;
		buff.filter = filter;
		buff:SetAlpha(1.0);
		buff:Show();

		-- Set filter-specific attributes
		if ( helpful ) then
			-- Anchor Buffs
			BuffedBuffButtonAnchors(buttonName, index);
		else
			-- Anchor Debuffs
			BuffedDebuffButtonAnchors(buttonName, index);

			-- Set color of debuff border based on dispel class.
			local debuffSlot = getglobal(buffName.."Border");
			if ( debuffSlot ) then
				local color;
				if ( debuffType ) then
					color = DebuffTypeColor[debuffType];
				else
					color = DebuffTypeColor["none"];
				end
				debuffSlot:SetVertexColor(color.r, color.g, color.b);
			end
		end

		if ( duration > 0 and expirationTime ) then
			if ( SHOW_BUFF_DURATIONS == "1" ) then
				buffDuration:Show();
			else
				buffDuration:Hide();
			end

			if ( not buff.timeLeft ) then
				buff.timeLeft = expirationTime - GetTime();
				buff:SetScript("OnUpdate", function(self, elapsed) BuffedButtonOnUpdate(self, elapsed, unit) end);
			else
				buff.timeLeft = expirationTime - GetTime();
			end
		else
			buffDuration:Hide();
			if ( buff.timeLeft ) then
				buff:SetScript("OnUpdate", nil);
			end
			buff.timeLeft = nil;
		end

		-- Set Texture
		local icon = getglobal(buffName.."Icon");
		icon:SetTexture(texture);

		-- Set the number of applications of an aura
		local buffCount = getglobal(buffName.."Count");
		if ( count > 1 ) then
			buffCount:SetText(count);
			buffCount:Show();
		else
			buffCount:Hide();
		end

		-- Refresh tooltip
		if ( GameTooltip:IsOwned(buff) ) then
			GameTooltip:SetUnitAura(unit, index, filter);
		end
	end
	return 1;
end


function BuffedUpdate(self, event, ...) -- my version of BuffFrame_Update()
	
	for i=1, BuffedFrameCreation.Buff.number do
		BuffedButtonUpdate("BuffedBuffButton", i, "HELPFUL", "player")
	end
	for i=1, BuffedFrameCreation.Debuff.number do
		BuffedButtonUpdate("BuffedDebuffButton", i, "HARMFUL", "player")
	end
	for i=1, BuffedFrameCreation.TargetBuff.number do
		BuffedButtonUpdate("TargetBuffedButton", i, "HELPFUL", "target")
	end
	for i=1, BuffedFrameCreation.TargetDebuff.number do
		BuffedButtonUpdate("TargetDebuffedButton", i, "HARMFUL", "target")
	end
	
end

local h = CreateFrame("Frame")
h:RegisterEvent("UNIT_AURA")
h:RegisterEvent("PLAYER_TARGET_CHANGED")
h:SetScript("OnEvent", BuffedUpdate)

function BuffFrame_Update()
end
function TargetFrame_UpdateAuras (self)
end
